<template>
  <aside :class="`sidebar -fix ${(toggle) ? '-in' : ''}`">

    <NuxtLink class="top" to="/">
      <div class="brand">
        <Icon name="brand" size="s"/>
      </div>
      PM <sup>2</sup>
    </NuxtLink>

    <button class="toggle-watchlist"
            v-if="this.$auth.loggedIn"
            @click="toggleWatchlist">
      <Icon name="stream" size="m" />
    </button>

    <div class="container" v-if="this.$auth.loggedIn">
      <ul>
        <li><h2>Watchlist</h2></li>
        <li v-for="s in subscriptions" :key="s.id">
          <NuxtLink :to="`/stream/${s.id}`">
            <Icon name="soccer" size="s"></Icon>
            {{ s.name }}
          </NuxtLink>
          <button @click="removeConfig(s.id)">
            <Icon name="times" size="s"/>
          </button>
        </li>

        <li>
          <NuxtLink class="-new" to="/stream/create">
            <Icon name="plus" size="s"></Icon>
            Create new stream
          </NuxtLink>
        </li>
      </ul>
    </div>

  </aside>
</template>

<script>
import Icon from "./Icon";

export default {
  name: 'Sidebar',
  components: {Icon},
  data() {
    return {
      toggle: false
    }
  },
  computed: {
    subscriptions() {
      return this.$store.getters['Stream/subscriptions'];
    }
  },
  methods: {
    async removeConfig(id) {
      let subscriptions = await this.$rest.Me.config.remove(id);
      this.$store.commit('Stream/UPDATE_SUBSCRIPTIONS', subscriptions);
    },

    toggleWatchlist(e) {
      this.toggle = (!this.toggle);
    }
  }
}
</script>

<style lang="scss">
.sidebar {
  position: relative;
  width: var(--width-sidebar);
  height: var(--height-sidebar);

  background: $color-sidebar;
  overflow: hidden;

  &.-in {
    height: 100%;
  }

  &.-fix {
    position: fixed;
    top: 0;
    left: 0;
    z-index: z-index('navbar');
  }

  .top {
    display: block;
    position: relative;
    width: 100%;
    padding: 0 $grid-gap;
    margin-bottom: 0;
    height: var(--height-topbar);

    @include _display-flex(flex, center, flex-start);
    @include _font-button('bold', $color-white);
    @include _font-size($font-size-l);

    @include _respond-to('desktops') {
      margin-bottom: $grid-gap*4;
    }
  }

  .brand {
    width: 35px;
    height: 35px;
    @include _display-flex(flex, center, center);
    margin-right: 10px;
    background-size: 200% auto;
    background: linear-gradient(to right, #02AAB0 0%, #00CDAC 51%, #02AAB0 100%);
    border-radius: 5px;
  }

  .toggle-watchlist {
    @include _reset-button;
    position: absolute;
    top: 12px;
    right: 8px;

    color: $color-white;

    @include _respond-to('desktops') {
      display: none;
    }
  }

  .container {
    margin: 0 $grid-gap $grid-gap*2 $grid-gap;
  }

  ul {
    @include _reset-lists;
    @include _list-child-margin(20px, 'li', 'bottom');

    h2 {
      @include _font-paragraph('bold', rgba($color-white, .4));
      @include _font-size($font-size-m);
      letter-spacing: 1px;
      text-transform: uppercase;
    }

    li {
      position: relative;

      a {
        @include _font-paragraph('bold', rgba($color-white, .7));
        @include _display-flex(flex, center, flex-start);

        .icon {
          position: relative;
          top: 1px;
          margin-right: $grid-gap;
          opacity: .5;
        }

        @include _link-active() {
          color: $color-white;
        }

        &.-new {
          @include _link-active() {
            color: $color-primary;
          }
        }
      }

      button {
        @include _reset-button;
        color: $color-white;
        position: absolute;
        top: calc(50% - 12px);
        right: 0;

        cursor: pointer;
        @include _transition(all);
        transform: scale(0);

        @include _link-active() {
          color: $color-hint;
        }
      }

      @include _link-active() {
        button {
          transform: scale(.85);
        }
      }
    }
  }

}
</style>
